import java.util.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.taskdefs.condition.*;

/**
 * takes node addresses as arguments. E.g., 1.4.3.2
 *
 * node address x is after node address y iff, where y has n places,
 * the values in the first n places of x are greater or equal to
 * their corresponding values in y
 */

public class IsAfter implements Condition {

	private String x = "";
	private String y = "";

    public boolean eval() {

		System.out.println( "x: " + x );
		System.out.println( "y: " + y );

		if ( x.equals("") || y.equals("") ) {
			throw new BuildException("Error - x or y not specified !!");
		}

		//check that both are in the form int.int.int

		//break into chambers
		String[] xs = x.split("\\.");
		String[] ys = y.split("\\.");

		//figure out n
		int n = ys.length;

		//step through, making sure x values are higher than or equal to y values
		for ( int i=0; i<n; i++ ) {
			int xValue = i<xs.length ? Integer.parseInt( xs[i] ) : 0;
			int yValue = Integer.parseInt( ys[i] );

			System.out.println( xValue + " " + yValue );
			if(  xValue < yValue ) {
				System.out.println("x not after y");
				return false;
			}

			if(  xValue > yValue ) {
				System.out.println("x is after y");
				return true;
			}
		}

		// if execution reaches here, first n places are equal
		System.out.println("x is after y");
		return true;
    }

    
	public void setX(String x) {
		this.x=x;
	}

	public void setY(String y) {
		this.y=y;
	}

}
