import java.util.*;
import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.taskdefs.condition.*;

/**
 * takes node addresses as arguments. E.g., 1.4.3.2
 *
 * node address x is a descendant of node address y iff, where y has n places,
 * x has n or more places, and the values in the first n places of x are equal
 * to the values in their corresponding places in y
 */

public class IsDescendantOf implements Condition {

	private String x = "";
	private String y = "";

    public boolean eval() {

		System.out.println( "x: " + x );
		System.out.println( "y: " + y );

		if ( x.equals("") || y.equals("") ) {
			throw new BuildException("Error - x or y not specified !!");
		}

		//check that both are in the form int.int.int

		//break into chambers
		String[] xs = x.split("\\.");
		String[] ys = y.split("\\.");

		//make sure x is at least as deep as y
		if ( xs.length < ys.length ) {
			System.out.println("x not descendant of y");
			return false;
		}

		//figure out n
		int n = ys.length;

		//step through, making sure x values are equal to y values
		for ( int i=0; i<n; i++ ) {
			int xValue = Integer.parseInt( xs[i] );
			int yValue = Integer.parseInt( ys[i] );

			System.out.println( xValue + " " + yValue );
			if(  xValue != yValue ) {
				System.out.println("x not descendant of y");
				return false;
			}
		}

		// if execution reaches here, first n places are equal
		System.out.println("x is descendant of y");
		return true;
    }

    
	public void setX(String x) {
		this.x=x;
	}

	public void setY(String y) {
		this.y=y;
	}

}
